﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication33
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            BindingList<MyBO> boDropdownList = new BindingList<MyBO>();
            boDropdownList.Add(new MyBO("Apple", 0, 0));
            boDropdownList.Add(new MyBO("Banana", 1, 1));
            boDropdownList.Add(new MyBO("Cherry", 2, 2));
            boDropdownList.Add(new MyBO("Grape", 3, 3));
            boDropdownList.Add(new MyBO("Watermelon", 4, 4));

            BindingSource uiLanguageListBindingSource = new BindingSource(boDropdownList, null);

            this.ultraCombo1.DisplayMember = "Name";
            this.ultraCombo1.ValueMember = "Id";
            this.ultraCombo1.SetDataBinding(uiLanguageListBindingSource, null);

            this.comboBox1.DisplayMember = "Name";
            this.comboBox1.ValueMember = "Id";
            this.comboBox1.DataSource = uiLanguageListBindingSource;


            BindingList<MyBO> boList = new BindingList<MyBO>();
            boList.Add(new MyBO("Apple", 0, 0));
            boList.Add(new MyBO("Banana", 1, 1));
            boList.Add(new MyBO("Cherry", 2, 2));
            boList.Add(new MyBO("Grape", 3, 3));
            boList.Add(new MyBO("Watermelon", 4, 4));

            BindingSource uiLanguageListEditSource = new BindingSource(boList, null);

            // This works. 
            //this.ultraCombo1.DataBindings.Add("Value", uiLanguageListEditSource, "Id");
            //this.comboBox1.DataBindings.Add("SelectedValue", uiLanguageListEditSource, "Id");

            // This does not work. 
            Binding binding = this.ultraCombo1.DataBindings.Add("Value", uiLanguageListEditSource, "NullableId");
            binding.Parse += new ConvertEventHandler(binding_Parse);            

            this.comboBox1.DataBindings.Add("SelectedValue", uiLanguageListEditSource, "NullableId");
        }

        void binding_Parse(object sender, ConvertEventArgs e)
        {
        }
    }
}
